﻿Imports System.Console

Module Module1
    Private n As Integer        'Jegyek száma
    Private hossz As Integer
    Private szakaszár As Integer
    Const ülések = 48

    Structure Jegyek
        Dim üles, fel, le As Integer
    End Structure
    Private jegy(500) As Jegyek

    Private m As Integer        'Megállók száma
    Private megállók(500) As Integer

    Sub Main()
        WriteLine("Helyjegy (Érettségi, 2010 május)")
        WriteLine()
        Feladat1()
        WriteLine()
        Feladat2()
        WriteLine()
        Feladat3()
        WriteLine()
        Feladat4()
        WriteLine()
        MegállókMeghatározása()
        WriteLine()
        Feladat5()
        WriteLine()
        Feladat6()
        WriteLine()
        Feladat7()
        WriteLine()
        ReadLine()
    End Sub

    Sub Feladat7()
        WriteLine("7. feladat. Utaslista adott pontban")
        Write("   A vizsgált hely = ")
        Dim hol = ReadLine()
        Dim lista(ülések) As String

        For i As Integer = 1 To ülések
            lista(i) = "üres"
        Next

        For i As Integer = 1 To n
            If hol >= jegy(i).fel And hol < jegy(i).le Then lista(jegy(i).üles) = i.ToString
        Next

        Dim fájl As IO.FileStream = New IO.FileStream("..\..\kihol.txt", IO.FileMode.Create, IO.FileAccess.Write)
        Dim író As IO.StreamWriter = New IO.StreamWriter(fájl)

        For i = 1 To ülések
            író.WriteLine(i & ".ülés: " & lista(i))
        Next
        író.Close()
        fájl.Close()

    End Sub

    Sub Feladat6()
        WriteLine("6. feladat. A busz a két végállomás között " & (m - 2).ToString & " helyen állt meg.")
    End Sub

    Sub Feladat5()
        Dim nfel, nle As Integer

        For i As Integer = 1 To n
            If jegy(i).fel = megállók(m - 1) Then nfel += 1
            If jegy(i).le = megállók(m - 1) Then nle += 1
        Next

        WriteLine("5. feladat. Az utolsó megállóban")
        WriteLine("   a felszállók száma: " & nfel)
        WriteLine("   a leszállók száma: " & nle)
    End Sub

    Sub MegállókMeghatározása()
        WriteLine("A megállók meghatározása...")
        Dim hely(2 * n) As Integer
        For i As Integer = 1 To n
            hely(2 * i - 1) = jegy(i).fel
            hely(2 * i) = jegy(i).le
        Next
        Array.Sort(hely)

        m = 1
        megállók(1) = hely(1)
        For i As Integer = 2 To 2 * n
            If hely(i) > hely(i - 1) Then
                m += 1
                megállók(m) = hely(i)
            End If
        Next

    End Sub

    Sub Feladat4()
        Dim bevétel As Integer = 0
        Dim ár As Integer = 0

        For i As Integer = 1 To n
            ár = (((jegy(i).le - jegy(i).fel - 1) \ 10) + 1) * szakaszár
            ár = Math.Round((ár) / 5) * 5
            WriteLine(ár)
            bevétel += ár
        Next

        WriteLine("4. feladat. A társaság bevétele " & bevétel & " Ft volt.")
    End Sub

    Sub Feladat3()
        WriteLine("3. feladat. Az utat a következő utasok utazták végig:")
        Write("   ")
        For i As Integer = 1 To n
            If jegy(i).fel = 0 And jegy(i).le = hossz Then
                Write(i & " ")
            End If
        Next
        WriteLine()
    End Sub

    Sub Feladat2()
        WriteLine("2. feladat. A legutolsó jegyvásárló")
        WriteLine("   ülésének száma: " & jegy(n).üles)
        WriteLine("   általa megett út: " & jegy(n).le - jegy(n).fel)
    End Sub

    Sub Feladat1()
        WriteLine("1. feladat. Az adatok beolvasása...")
        Dim fájl As IO.FileStream = New IO.FileStream("..\..\eladott.txt", IO.FileMode.Open, IO.FileAccess.Read)
        Dim olvasó As IO.StreamReader = New IO.StreamReader(fájl)
        Dim egysor() As String

        egysor = olvasó.ReadLine().Split(" ")
        n = CInt(egysor(0))
        hossz = CInt(egysor(1))
        szakaszár = CInt(egysor(2))

        For i As Integer = 1 To n
            egysor = olvasó.ReadLine().Split(" ")
            jegy(i).üles = CInt(egysor(0))
            jegy(i).fel = CInt(egysor(1))
            jegy(i).le = CInt(egysor(2))
        Next
        olvasó.Close()
        fájl.Close()
    End Sub

End Module
